local sti = require "sti"

function love.load()
    map = sti.new("map/themap")
	--love.physics.setMeter(32)
	world = love.physics.newWorld(0, 9.81*64, true)
	world:setCallbacks(beginContact, endContact, preSolve, postSolve)
    collision = map:initWorldCollision(world)
	
	text = ""
	
	--Player
	map:addCustomLayer("Player Layer", 2)	
	player = map.layers["Player Layer"]
	player.body = love.physics.newBody(world, 170, 20, "dynamic")
	player.shape = love.physics.newRectangleShape(60, 70)
	player.fixture = love.physics.newFixture(player.body, player.shape, 3)
	--player.body:setFixedRotation(true)
	px, py = player.body:getPosition()

end

function love.update(dt)
    world:update(dt)
	map:update(dt)
	px = player.body:getX()
	py = player.body:getY()
	psx = 0
	psy = 20
	
	
	-- Control
	down = love.keyboard.isDown
	if down("a") then psx = -4 end
	if down("d") then psx = 4 end
	player.body:setX(px + psx)
end

function love.draw()
    map:draw()
	love.graphics.polygon("fill", player.body:getWorldPoints(player.shape:getPoints()))
	love.graphics.print(text, 20, 20)
	if bx1 then love.graphics.line(bx1, by1, bx2, by2) end
	 map:drawWorldCollision(collision)
end

function beginContact(a, b, coll)
	--text = a:getType()
	
end

function preSolve(a, b, coll)
	bx1, by1, bx2, by2 = a:getBoundingBox()
	if down("r") then a:destroy() end
end

function endContact()
text = ""
end